"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ContinuousLegend = void 0;

var _leaflet = _interopRequireDefault(require("leaflet"));

var _utils = require("./utils.js");

var _covutils = require("covutils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DEFAULT_TEMPLATE_ID = 'template-coverage-parameter-continuous-legend';
var DEFAULT_TEMPLATE = "<template id=\"".concat(DEFAULT_TEMPLATE_ID, "\">\n  <div class=\"leaflet-coverage-control legend continuous-legend\">\n    <div style=\"margin-bottom:3px\" class=\"legend-title-container\">\n      <strong class=\"legend-title\"></strong>\n    </div>\n    <div style=\"display: inline-block; height: 144px; float:left\">\n      <span style=\"height: 136px; width: 18px; display: block; margin-top: 9px;\" class=\"legend-palette\"></span>\n    </div>\n    <div style=\"display: inline-block; float:left; height:153px\">\n      <table style=\"height: 100%;\">\n        <tr><td style=\"vertical-align:top\"><span class=\"legend-max\"></span> <span class=\"legend-uom\"></span></td></tr>\n        <tr><td><span class=\"legend-current\"></span></td></tr>\n        <tr><td style=\"vertical-align:bottom\"><span class=\"legend-min\"></span> <span class=\"legend-uom\"></span></td></tr>\n      </table>\n    </div>\n  </div>\n</template>");
/**
 * Displays a continuous legend for the parameter displayed by the given
 * coverage data layer.
 * 
 * Note that this class should only be used if the palette is continuous
 * by nature, typically having at least 100-200 color steps.
 * If there are only a few color steps (e.g. 10), then this class
 * will still show a continuous legend due to its rendering technique
 * (CSS gradient based).
 * 
 * @example <caption>Coverage data layer</caption>
 * new C.ContinuousLegend(covLayer).addTo(map)
 * // changing the palette of the layer automatically updates the legend 
 * covLayer.palette = C.linearPalette(['blue', 'red'])
 * 
 * @example <caption>Fake layer</caption>
 * var fakeLayer = {
 *   parameter: {
 *     observedProperty: {
 *       label: { en: 'Temperature' }
 *     },
 *     unit: {
 *       symbol: { value: 'K' },
 *       label: { en: 'Kelvin' }
 *     }
 *   },
 *   palette: linearPalette(['#FFFFFF', '#000000']),
 *   paletteExtent: [0, 10]
 * }
 * var legend = new C.ContinuousLegend(fakeLayer).addTo(map)
 * 
 * // change the palette and trigger a manual update
 * fakeLayer.palette = C.linearPalette(['blue', 'red'])
 * legend.update()
 * 
 * @extends {L.Control}
 */

var ContinuousLegend = /*#__PURE__*/function (_L$Control) {
  _inherits(ContinuousLegend, _L$Control);

  var _super = _createSuper(ContinuousLegend);

  /**
   * Creates a continuous legend control.
   * 
   * @param {object} covLayer 
   *   The coverage data layer, or any object with <code>palette</code>,
   *   <code>paletteExtent</code>, and <code>parameter</code> properties.
   *   If the object has <code>on</code>/<code>off</code> methods, then the legend will
   *   listen for <code>"paletteChange"</code> and <code>"paletteExtentChange"</code>
   *   events and update itself automatically.
   *   If the layer fires a <code>"remove"</code> event, then the legend will remove itself
   *   from the map. 
   * @param {object} [options] Legend options.
   * @param {string} [options.position='bottomright'] The initial position of the control (see Leaflet docs).
   * @param {string} [options.language] A language tag, indicating the preferred language to use for labels.
   * @param {string} [options.templateId] Uses the HTML element with the given id as template.
   */
  function ContinuousLegend(covLayer) {
    var _this;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, ContinuousLegend);

    _this = _super.call(this, {
      position: options.position || 'bottomright'
    });
    _this._covLayer = covLayer;
    _this._templateId = options.templateId || DEFAULT_TEMPLATE_ID;
    _this._language = options.language;

    if (!options.templateId && document.getElementById(DEFAULT_TEMPLATE_ID) === null) {
      (0, _utils.inject)(DEFAULT_TEMPLATE);
    }

    if (covLayer.on) {
      _this._remove = function () {
        return _this.remove();
      };

      _this._update = function () {
        return _this._doUpdate(false);
      };

      covLayer.on('remove', _this._remove);
    }

    return _this;
  }
  /**
   * Triggers a manual update of the legend.
   * 
   * Useful if the supplied coverage data layer is not a real layer
   * and won't fire the necessary events for automatic updates.
   */


  _createClass(ContinuousLegend, [{
    key: "update",
    value: function update() {
      this._doUpdate(true);
    }
  }, {
    key: "_doUpdate",
    value: function _doUpdate(fullUpdate) {
      var el = this._el;

      if (fullUpdate) {
        var param = this._covLayer.parameter; // if requested language doesn't exist, use the returned one for all other labels

        var language = (0, _covutils.getLanguageTag)(param.observedProperty.label, this._language);
        var title = (0, _covutils.getLanguageString)(param.observedProperty.label, language);
        var unit = (0, _covutils.stringifyUnit)(param.unit, language);
        (0, _utils.$$)('.legend-title', el).innerHTML = title;
        (0, _utils.$)('.legend-uom', el).forEach(function (u) {
          return u.innerHTML = unit;
        });
      }

      var palette = this._covLayer.palette;

      var _this$_covLayer$palet = _slicedToArray(this._covLayer.paletteExtent, 2),
          low = _this$_covLayer$palet[0],
          high = _this$_covLayer$palet[1];

      (0, _utils.$$)('.legend-min', el).innerHTML = low.toFixed(2);
      (0, _utils.$$)('.legend-max', el).innerHTML = high.toFixed(2);
      var gradient = '';

      for (var i = 0; i < palette.steps; i++) {
        if (i > 0) gradient += ',';
        gradient += 'rgb(' + palette.red[i] + ',' + palette.green[i] + ',' + palette.blue[i] + ')';
      }

      (0, _utils.$$)('.legend-palette', el).style.background = 'transparent linear-gradient(to top, ' + gradient + ') repeat scroll 0% 0%';
    }
    /**
     * @override
     * @ignore
     */

  }, {
    key: "onAdd",
    value: function onAdd(map) {
      this._map = map;

      if (this._covLayer.on) {
        this._covLayer.on('paletteChange', this._update);

        this._covLayer.on('paletteExtentChange', this._update);
      }

      this._el = (0, _utils.fromTemplate)(this._templateId);
      this.update();
      return this._el;
    }
    /**
     * @override
     * @ignore
     */

  }, {
    key: "onRemove",
    value: function onRemove() {
      if (this._covLayer.off) {
        this._covLayer.off('remove', this._remove);

        this._covLayer.off('paletteChange', this._update);

        this._covLayer.off('paletteExtentChange', this._update);
      }
    }
  }]);

  return ContinuousLegend;
}(_leaflet.default.Control);

exports.ContinuousLegend = ContinuousLegend;