"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Dropdown = void 0;

var _leaflet = _interopRequireDefault(require("leaflet"));

var _utils = require("./utils.js");

var _EventMixin2 = require("../util/EventMixin.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DEFAULT_TEMPLATE_ID = 'template-coverage-dropdown';
var DEFAULT_TEMPLATE = "<template id=\"".concat(DEFAULT_TEMPLATE_ID, "\">\n<div class=\"leaflet-coverage-control\" style=\"clear:none\">\n  <strong class=\"select-title\"></strong><br>\n  <select class=\"form-control\"></select>\n</div>\n</template>");
/**
 * The `change` event, signalling that a different dropdown element has been selected.
 * 
 * @typedef {L.Event} Dropdown#change
 * @property {string} value The value of the selected item.
 */

/**
 * An event-enabled dropdown control with optional title.
 * 
 * Used in {@link VerticalAxis}.
 * 
 * @extends {L.Control}
 * @extends {EventMixin}
 * 
 * @emits {Dropdown#change} when a different dropdown element has been selected
 */

var Dropdown = /*#__PURE__*/function (_EventMixin) {
  _inherits(Dropdown, _EventMixin);

  var _super = _createSuper(Dropdown);

  /**
   * @param {Array<Object>} choices The dropdown items given as an array of `{value, label}` objects.
   * @param {Object} [options] The options object.
   * @param {string} [options.position='topleft'] The position of the control (one of the map corners).
   *    Possible values are 'topleft', 'topright', 'bottomleft' or 'bottomright'.
   * @param {string} [options.title] The dropdown title that is displayed above the dropdown.
   * @param {string} [options.value] Value of the item that should be initially selected.
   * @param {string} [options.templateId] Element ID of an alternative HTML `<template>` element to use.
   */
  function Dropdown(choices) {
    var _this;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Dropdown);

    _this = _super.call(this, options.position ? {
      position: options.position
    } : {
      position: 'topleft'
    });
    _this._templateId = options.templateId || DEFAULT_TEMPLATE_ID;
    _this._title = options.title || '';
    _this._choices = choices;
    _this._value = options.value || choices[0].value;

    if (!options.templateId && document.getElementById(DEFAULT_TEMPLATE_ID) === null) {
      (0, _utils.inject)(DEFAULT_TEMPLATE);
    }

    return _this;
  }
  /**
   * @override
   * @ignore
   */


  _createClass(Dropdown, [{
    key: "onAdd",
    value: function onAdd(map) {
      var _this2 = this;

      var el = (0, _utils.fromTemplate)(this._templateId);
      this._el = el;

      _leaflet.default.DomEvent.disableClickPropagation(el);

      (0, _utils.$$)('.select-title', el).innerHTML = this._title;

      var _iterator = _createForOfIteratorHelper(this._choices),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _step$value = _step.value,
              value = _step$value.value,
              label = _step$value.label;
          (0, _utils.$$)('select', el).appendChild((0, _utils.HTML)("<option value=\"".concat(value, "\">").concat(label, "</option>")));
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      (0, _utils.$$)('select', el).disabled = this._choices.length <= 1;
      this.value = this._value;
      (0, _utils.$$)('select', el).addEventListener('change', function (event) {
        _this2._value = event.target.value;

        _this2.fire('change', {
          value: event.target.value
        });
      });
      return el;
    }
    /** 
     * Returns the value of the currently selected item.
     * 
     * @type {string}
     * 
     * @example
     * let current = dropdown.value
     */

  }, {
    key: "value",
    get: function get() {
      return this._value;
    }
    /** 
     * Selects the item with the given value.
     * 
     * @type {string}
     * 
     * @example
     * dropdown.value = 'foobar'
     */
    ,
    set: function set(val) {
      (0, _utils.$$)('select', this._el).value = val;
    }
  }]);

  return Dropdown;
}((0, _EventMixin2.EventMixin)(_leaflet.default.Control));

exports.Dropdown = Dropdown;