"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TimeAxis = void 0;

var _leaflet = _interopRequireDefault(require("leaflet"));

var _utils = require("./utils.js");

var _EventMixin2 = require("../util/EventMixin.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DEFAULT_TEMPLATE_ID = 'template-coverage-timeaxis';
var DEFAULT_TEMPLATE = "<template id=\"".concat(DEFAULT_TEMPLATE_ID, "\">\n<div class=\"leaflet-coverage-control form-inline\" style=\"clear:none\">\n  <strong class=\"title\">Time</strong><br>\n  <div class=\"form-group\">\n    <select name=\"date\" class=\"date form-control\"></select>\n  </div>\n  <div class=\"form-group\">\n    <select name=\"time\" class=\"time form-control\"></select>\n  </div>\n</div>\n</template>");
/**
 * The `change` event, signalling that a different time entry has been selected.
 * 
 * @typedef {L.Event} TimeAxis#change
 * @property {Date} time The time that has been selected.
 */

/**
 * Displays a simple date/time picker for a coverage data layer by grouping
 * time steps into dates and times.
 * 
 * @example <caption>Coverage data layer</caption>
 * new C.TimeAxis(covLayer).addTo(map)
 * // Selecting a date/time automatically sets the 'time' property in the layer.
 * // Similarly, when the layer fires an 'axisChange' event with {axis: 'time'}
 * // the control reflects that change.
 * 
 * @example <caption>Fake layer</caption>
 * var times = ['2000-01-01T00:00:00Z','2000-01-01T05:00:00Z'].map(s => new Date(s))
 * var fakeLayer = {
 *   timeSlices: times,
 *   time: times[1] // select the second time step initially
 * }
 * var timeAxis = new C.TimeAxis(fakeLayer).addTo(map)
 * 
 * // change the time and trigger a manual update
 * fakeLayer.time = times[0]
 * timeAxis.update()
 * 
 * @extends {L.Control}
 * @extends {EventMixin}
 * 
 * @emits {TimeAxis#change} when a different time entry has been selected
 */

var TimeAxis = /*#__PURE__*/function (_EventMixin) {
  _inherits(TimeAxis, _EventMixin);

  var _super = _createSuper(TimeAxis);

  /**
   * Creates a time axis control.
   * 
   * @param {object} covLayer 
   *   The coverage data layer, or any object with `timeSlices` and `time` properties.
   *   If the object has `on`/`off` methods, then the control will
   *   listen for `axisChange` events with `{axis: 'time'}` and update itself automatically.
   *   If the layer fires a `remove` event, then the control will remove itself from the map.
   * @param {object} [options] Control options.
   * @param {string} [options.position='topleft'] The initial position of the control (see Leaflet docs).
   * @param {string} [options.title='Time'] The label to show above the date/time picker.
   * @param {string} [options.templateId] Element ID of an alternative HTML `<template>` element to use.
   */
  function TimeAxis(covLayer) {
    var _this;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, TimeAxis);

    _this = _super.call(this, {
      position: options.position || 'topleft'
    });
    _this._templateId = options.templateId || DEFAULT_TEMPLATE_ID;
    _this._title = options.title || 'Time';
    _this._covLayer = covLayer;

    if (!options.templateId && document.getElementById(DEFAULT_TEMPLATE_ID) === null) {
      (0, _utils.inject)(DEFAULT_TEMPLATE);
    }

    if (covLayer.on) {
      _this._remove = function () {
        return _this.remove();
      };

      covLayer.on('remove', _this._remove);

      _this._axisListener = function (e) {
        if (e.axis === 'time') _this.update();
      };
    }

    var timeSlices = _this._covLayer.timeSlices;
    var dateMap = new Map(); // UTC timestamp (representing the date only) -> array of Date objects

    var _iterator = _createForOfIteratorHelper(timeSlices),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var t = _step.value;
        var dateTimestamp = new Date(Date.UTC(t.getUTCFullYear(), t.getUTCMonth(), t.getUTCDate())).getTime();

        if (!dateMap.has(dateTimestamp)) {
          dateMap.set(dateTimestamp, []);
        }

        dateMap.get(dateTimestamp).push(t);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    _this._dateMap = dateMap;
    return _this;
  }
  /**
   * @ignore
   */


  _createClass(TimeAxis, [{
    key: "onAdd",
    value: function onAdd(map) {
      var _this2 = this;

      this._map = map;

      if (this._covLayer.on) {
        this._covLayer.on('axisChange', this._axisListener);
      }

      var el = (0, _utils.fromTemplate)(this._templateId);
      this._el = el;

      _leaflet.default.DomEvent.disableClickPropagation(el);

      if (this._title) {
        (0, _utils.$$)('.title', el).innerHTML = this._title;
      }

      var _iterator2 = _createForOfIteratorHelper(this._dateMap.keys()),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var dateTimestamp = _step2.value;
          var dateStr = getUTCDateString(dateTimestamp);
          (0, _utils.$$)('.date', el).appendChild((0, _utils.HTML)("<option value=\"".concat(dateStr, "\">").concat(dateStr, "</option>")));
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      (0, _utils.$$)('.date', el).disabled = this._dateMap.size === 1;
      (0, _utils.$$)('.date', el).addEventListener('change', function (event) {
        var dateTimestamp = getUTCTimestampDateOnly(event.target.value);

        var timeSlice = _this2._dateMap.get(dateTimestamp)[0];

        _this2._covLayer.time = timeSlice;

        _this2._initTimeSelect(dateTimestamp);

        _this2.fire('change', {
          time: timeSlice
        });
      });
      (0, _utils.$$)('.time', el).addEventListener('change', function (event) {
        var dateStr = (0, _utils.$$)('.date', el).value;
        var timeStr = event.target.value;
        var time = new Date(dateStr + 'T' + timeStr);
        _this2._covLayer.time = time;

        _this2.fire('change', {
          time: time
        });
      });
      this.update();
      return el;
    }
    /**
     * @ignore
     */

  }, {
    key: "onRemove",
    value: function onRemove() {
      if (this._covLayer.off) {
        this._covLayer.off('remove', this._remove);

        this._covLayer.off('axisChange', this._axisListener);
      }
    }
    /**
     * Triggers a manual update of the date/time picker based on the
     * `time` property of the layer.
     * 
     * Useful if the supplied coverage data layer is not a real layer
     * and won't fire the necessary events for automatic updates.
     */

  }, {
    key: "update",
    value: function update() {
      var covTime = this._covLayer.time;
      if (!covTime) return;
      var el = this._el; // selects the date set in the cov layer, populates the time select, and selects the time

      var dateTimestamp = getUTCTimestampDateOnly(covTime.toISOString());
      var dateStr = getUTCDateString(dateTimestamp);
      (0, _utils.$$)('.date', el).value = dateStr;

      this._initTimeSelect(dateTimestamp);

      var timeStr = covTime.toISOString().substr(11);
      (0, _utils.$$)('.time', el).value = timeStr;
    }
  }, {
    key: "_initTimeSelect",
    value: function _initTimeSelect(dateTimestamp) {
      var el = this._el;
      var timeSelect = (0, _utils.$$)('.time', el);
      timeSelect.innerHTML = '';

      var times = this._dateMap.get(dateTimestamp);

      var _iterator3 = _createForOfIteratorHelper(times),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var timeSlice = _step3.value;
          var timeStr = timeSlice.toISOString().substr(11);
          timeSelect.appendChild((0, _utils.HTML)("<option value=\"".concat(timeStr, "\">").concat(timeStr, "</option>")));
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      timeSelect.disabled = times.length === 1;
    }
  }]);

  return TimeAxis;
}((0, _EventMixin2.EventMixin)(_leaflet.default.Control));

exports.TimeAxis = TimeAxis;

function getUTCTimestampDateOnly(dateStr) {
  var year = parseInt(dateStr.substr(0, 4));
  var month = parseInt(dateStr.substr(5, 2));
  var day = parseInt(dateStr.substr(8, 2));
  return Date.UTC(year, month - 1, day);
}

function getUTCDateString(timestamp) {
  var iso = new Date(timestamp).toISOString();
  var date = iso.substr(0, 10);
  return date;
}