/**
 * This file contains several external identifier definitions for ESDoc which are used throughout
 * the code in method/function/class doc strings.
 */
// ESDoc can't handle multiple @external definitions in a single comment block, each has to be in its own block.

/**
 * @external {HTMLElement} https://developer.mozilla.org/en/docs/Web/API/HTMLElement
 */

/**
 * @external {HTMLCanvasElement} https://developer.mozilla.org/en-US/docs/Web/API/HTMLCanvasElement
 */

/**
 * @external {L} http://leafletjs.com/reference-1.0.0.html
 */

/**
 * @external {L.LatLng} http://leafletjs.com/reference-1.0.0.html#latlng
 */

/**
 * @external {L.LatLngBounds} http://leafletjs.com/reference-1.0.0.html#latlngbounds
 */

/**
 * @external {L.Point} http://leafletjs.com/reference-1.0.0.html#point
 */

/**
 * @external {L.Map} http://leafletjs.com/reference-1.0.0.html#map
 */

/**
 * @external {L.Layer} http://leafletjs.com/reference-1.0.0.html#layer
 */

/**
 * @external {L.GridLayer} http://leafletjs.com/reference-1.0.0.html#gridlayer
 */

/**
 * @external {L.Control} http://leafletjs.com/reference-1.0.0.html#control
 */

/**
 * @external {L.Draggable} http://leafletjs.com/reference-1.0.0.html#draggable
 */

/**
 * @external {L.Popup} http://leafletjs.com/reference-1.0.0.html#popup
 */

/**
 * @external {L.Marker} http://leafletjs.com/reference-1.0.0.html#marker
 */

/**
 * @external {L.GeoJSON} http://leafletjs.com/reference-1.0.0.html#geojson
 */

/**
 * @external {L.Evented} http://leafletjs.com/reference-1.0.0.html#evented
 */

/**
 * @external {L.Event} http://leafletjs.com/reference-1.0.0.html#event
 */

/**
 * @external {CovUtils} https://doc.esdoc.org/github.com/Reading-eScience-Centre/covutils/
 */

/**
 * @external {Coverage} https://github.com/Reading-eScience-Centre/coverage-jsapi/blob/master/Coverage.md
 */

/**
 * @external {CoverageCollection} https://github.com/Reading-eScience-Centre/coverage-jsapi/blob/master/CoverageCollection.md
 */

/**
 * @external {Domain} https://github.com/Reading-eScience-Centre/coverage-jsapi/blob/master/Domain.md
 */

/**
 * @external {Parameter} https://github.com/Reading-eScience-Centre/coverage-jsapi/blob/master/Parameter.md
 */

/**
 * @external {c3} http://c3js.org/reference.html
 */
"use strict";