"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  legend: true,
  DiscreteLegend: true,
  ContinuousLegend: true,
  TimeAxis: true,
  VerticalAxis: true,
  Dropdown: true,
  Grid: true,
  VerticalProfile: true,
  Trajectory: true,
  Point: true,
  PointSeries: true,
  MultiPolygon: true,
  PolygonSeries: true,
  PointCollection: true,
  VerticalProfileCollection: true,
  ParameterSync: true,
  PaletteMixin: true,
  CoverageMixin: true,
  CircleMarkerMixin: true,
  VerticalProfilePlot: true,
  TimeSeriesPlot: true,
  DraggableValuePopup: true,
  ValuePopup: true,
  DraggablePopupMixin: true
};
Object.defineProperty(exports, "CircleMarkerMixin", {
  enumerable: true,
  get: function get() {
    return _CircleMarkerMixin.CircleMarkerMixin;
  }
});
Object.defineProperty(exports, "ContinuousLegend", {
  enumerable: true,
  get: function get() {
    return _ContinuousLegend.ContinuousLegend;
  }
});
Object.defineProperty(exports, "CoverageMixin", {
  enumerable: true,
  get: function get() {
    return _CoverageMixin.CoverageMixin;
  }
});
Object.defineProperty(exports, "DiscreteLegend", {
  enumerable: true,
  get: function get() {
    return _DiscreteLegend.DiscreteLegend;
  }
});
Object.defineProperty(exports, "DraggablePopupMixin", {
  enumerable: true,
  get: function get() {
    return _DraggablePopupMixin.DraggablePopupMixin;
  }
});
Object.defineProperty(exports, "DraggableValuePopup", {
  enumerable: true,
  get: function get() {
    return _DraggableValuePopup.DraggableValuePopup;
  }
});
Object.defineProperty(exports, "Dropdown", {
  enumerable: true,
  get: function get() {
    return _Dropdown.Dropdown;
  }
});
Object.defineProperty(exports, "Grid", {
  enumerable: true,
  get: function get() {
    return _Grid.Grid;
  }
});
Object.defineProperty(exports, "MultiPolygon", {
  enumerable: true,
  get: function get() {
    return _MultiPolygon.MultiPolygon;
  }
});
Object.defineProperty(exports, "PaletteMixin", {
  enumerable: true,
  get: function get() {
    return _PaletteMixin.PaletteMixin;
  }
});
Object.defineProperty(exports, "ParameterSync", {
  enumerable: true,
  get: function get() {
    return _ParameterSync.ParameterSync;
  }
});
Object.defineProperty(exports, "Point", {
  enumerable: true,
  get: function get() {
    return _Point.Point;
  }
});
Object.defineProperty(exports, "PointCollection", {
  enumerable: true,
  get: function get() {
    return _PointCollection.PointCollection;
  }
});
Object.defineProperty(exports, "PointSeries", {
  enumerable: true,
  get: function get() {
    return _PointSeries.PointSeries;
  }
});
Object.defineProperty(exports, "PolygonSeries", {
  enumerable: true,
  get: function get() {
    return _PolygonSeries.PolygonSeries;
  }
});
Object.defineProperty(exports, "TimeAxis", {
  enumerable: true,
  get: function get() {
    return _TimeAxis.TimeAxis;
  }
});
Object.defineProperty(exports, "TimeSeriesPlot", {
  enumerable: true,
  get: function get() {
    return _TimeSeriesPlot.TimeSeriesPlot;
  }
});
Object.defineProperty(exports, "Trajectory", {
  enumerable: true,
  get: function get() {
    return _Trajectory.Trajectory;
  }
});
Object.defineProperty(exports, "ValuePopup", {
  enumerable: true,
  get: function get() {
    return _ValuePopup.ValuePopup;
  }
});
Object.defineProperty(exports, "VerticalAxis", {
  enumerable: true,
  get: function get() {
    return _VerticalAxis.VerticalAxis;
  }
});
Object.defineProperty(exports, "VerticalProfile", {
  enumerable: true,
  get: function get() {
    return _VerticalProfile.VerticalProfile;
  }
});
Object.defineProperty(exports, "VerticalProfileCollection", {
  enumerable: true,
  get: function get() {
    return _VerticalProfileCollection.VerticalProfileCollection;
  }
});
Object.defineProperty(exports, "VerticalProfilePlot", {
  enumerable: true,
  get: function get() {
    return _VerticalProfilePlot.VerticalProfilePlot;
  }
});
Object.defineProperty(exports, "legend", {
  enumerable: true,
  get: function get() {
    return _Legend.legend;
  }
});

var _Legend = require("./controls/Legend.js");

var _DiscreteLegend = require("./controls/DiscreteLegend.js");

var _ContinuousLegend = require("./controls/ContinuousLegend.js");

var _TimeAxis = require("./controls/TimeAxis.js");

var _VerticalAxis = require("./controls/VerticalAxis.js");

var _Dropdown = require("./controls/Dropdown.js");

var _factory = require("./layers/factory.js");

Object.keys(_factory).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _factory[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _factory[key];
    }
  });
});

var _Grid = require("./layers/Grid.js");

var _VerticalProfile = require("./layers/VerticalProfile.js");

var _Trajectory = require("./layers/Trajectory.js");

var _Point = require("./layers/Point.js");

var _PointSeries = require("./layers/PointSeries.js");

var _MultiPolygon = require("./layers/MultiPolygon.js");

var _PolygonSeries = require("./layers/PolygonSeries.js");

var _PointCollection = require("./layers/PointCollection.js");

var _VerticalProfileCollection = require("./layers/VerticalProfileCollection.js");

var _palettes = require("./layers/palettes.js");

Object.keys(_palettes).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _palettes[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _palettes[key];
    }
  });
});

var _ParameterSync = require("./layers/ParameterSync.js");

var _PaletteMixin = require("./layers/PaletteMixin.js");

var _CoverageMixin = require("./layers/CoverageMixin.js");

var _CircleMarkerMixin = require("./layers/CircleMarkerMixin.js");

var _VerticalProfilePlot = require("./popups/VerticalProfilePlot.js");

var _TimeSeriesPlot = require("./popups/TimeSeriesPlot.js");

var _DraggableValuePopup = require("./popups/DraggableValuePopup.js");

var _ValuePopup = require("./popups/ValuePopup.js");

var _DraggablePopupMixin = require("./popups/DraggablePopupMixin.js");

var _constants = require("./util/constants.js");

Object.keys(_constants).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _constants[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _constants[key];
    }
  });
});