"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Grid = void 0;

var _leaflet = _interopRequireDefault(require("leaflet"));

var _ndarray = _interopRequireDefault(require("ndarray"));

var _covutils = require("covutils");

var _palettes = require("./palettes.js");

var _PaletteMixin2 = require("./PaletteMixin.js");

var _CoverageMixin = require("./CoverageMixin.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * Renderer for Coverages and Domains conforming to the `Grid` domain type of CovJSON.
 * For Domain objects, a dummy parameter and range data is created.
 * 
 * @example
 * var cov = ... // get Coverage data
 * var layer = new C.Grid(cov, {
 *   parameter: 'salinity',
 *   time: new Date('2015-01-01T12:00:00Z'),
 *   vertical: 50,
 *   palette: C.linearPalette(['#FFFFFF', '#000000']),
 *   paletteExtent: 'subset'
 * })
 * 
 * @see https://covjson.org/domain-types/#grid
 * 
 * @emits {DataLayer#afterAdd} Layer is initialized and was added to the map
 * @emits {DataLayer#dataLoading} Data loading has started
 * @emits {DataLayer#dataLoad} Data loading has finished (also in case of errors)
 * @emits {DataLayer#error} Error when loading data
 * @emits {DataLayer#axisChange} Axis coordinate has changed (e.axis === 'time'|'vertical')
 * @emits {PaletteMixin#paletteChange} Palette has changed
 * @emits {PaletteMixin#paletteExtentChange} Palette extent has changed
 * 
 * @extends {L.GridLayer}
 * @extends {CoverageMixin}
 * @extends {PaletteMixin}
 * @implements {DataLayer}
 */
var Grid = /*#__PURE__*/function (_PaletteMixin) {
  _inherits(Grid, _PaletteMixin);

  var _super = _createSuper(Grid);

  /**
   * The key of the parameter to display must be given in the 'parameter' options property,
   * except when the coverage data object is a Domain object.
   * 
   * Optional time and vertical axis target values can be defined with the 'time' and
   * 'vertical' options properties. The closest values on the respective axes are chosen.
   * 
   * @param {Coverage|Domain} cov The coverage or domain object to visualize.
   * @param {Object} [options] The options object.
   * @param {string} [options.parameter] The key of the parameter to display, not needed for domain objects.
   * @param {Date} [options.time] The initial time slice to display, defaults to the first one.
   * @param {number} [options.vertical] The initial vertical slice to display, defaults to the first one.
   * @param {Palette} [options.palette] The initial color palette to use, the default depends on the parameter type.
   * @param {string} [options.paletteExtent='subset'] The initial palette extent, one of 
   *  `subset` (computed from data of current time/vertical slice),
   *  `fov` (computed from data in map field of view; not implemented yet),
   *  or specific: [-10,10].
   * @param {boolean} [options.valueToColor] If present, the value is converted to a color using the given function,
   *  and palette settings are ignored.  The returned color should be of the form `{r: 0, g: 0, b: 0, a: 255}`.
   */
  function Grid(cov) {
    var _this;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Grid);

    _this = _super.call(this);

    if ((0, _covutils.isDomain)(cov)) {
      cov = (0, _covutils.fromDomain)(cov);
      options.parameter = cov.parameters.keys().next().value;
      delete options.keys;
    }

    if (!options.paletteExtent) {
      options.paletteExtent = 'subset';
    }

    _leaflet.default.Util.setOptions(_assertThisInitialized(_this), options);

    _this._cov = cov;
    _this._param = cov.parameters.get(options.keys ? options.keys[0] : options.parameter);
    _this._axesSubset = {
      // x and y are not subsetted
      t: {
        coordPref: options.time ? options.time.toISOString() : undefined
      },
      z: {
        coordPref: options.vertical
      }
    };
    /**
     * The vertical reference system object, used by {@link VerticalAxis}.
     * @type {Object}
     */

    _this.crsVerticalAxis = undefined;
    return _this;
  }
  /**
   * @ignore
   * @override
   */


  _createClass(Grid, [{
    key: "onAdd",
    value: function onAdd(map) {
      var _this2 = this;

      // "loading" and "load" events are provided by the underlying GridLayer class
      this._map = map;
      this.load().then(function () {
        return _this2.initializePalette();
      }).then(function () {
        // used in controls/VerticalAxis.js
        var vertRef = (0, _covutils.getReferenceObject)(_this2.domain, 'z');

        if (vertRef && vertRef.coordinates.length === 1) {
          var vertRefSys = vertRef.system;

          if (vertRefSys.cs && (vertRefSys.cs.csAxes || vertRefSys.cs.axes)) {
            _this2.crsVerticalAxis = vertRefSys.cs.csAxes ? vertRefSys.cs.csAxes[0] : vertRefSys.cs.axes[0];
          }
        } else {// TODO handle vertical axis part of 3D CRS
        }
      }).then(function () {
        _this2._errored = false;

        _get(_getPrototypeOf(Grid.prototype), "onAdd", _this2).call(_this2, map);

        _this2.fire('afterAdd');
      }).catch(function (e) {
        _this2._errored = true;
        console.log(e);

        _get(_getPrototypeOf(Grid.prototype), "onAdd", _this2).call(_this2, map);
      });
    }
    /**
     * @ignore
     * @override
     */

  }, {
    key: "onRemove",
    value: function onRemove(map) {
      delete this._map; // TODO delete references to domain/range, caching logic should happen elsewhere

      _get(_getPrototypeOf(Grid.prototype), "onRemove", this).call(this, map);
    }
    /**
     * Returns the geographic bounds of the coverage.
     * 
     * For projected coverages this is an approximation based on unprojecting the four bounding box corners
     * and fitting all four points into a geographic bounding box.
     * 
     * @returns {L.LatLngBounds}
     */

  }, {
    key: "getBounds",
    value: function getBounds() {
      var bbox;

      if (this._cov.bbox) {
        bbox = this._cov.bbox;
      } else {
        bbox = this._getDomainBbox();
        var proj = this.projection; // for projected CRSs this approximates the geographic bbox by unprojecting the projected bbox corners
        // for geographic CRSs the result will be identical 

        var p1 = proj.unproject({
          x: bbox[0],
          y: bbox[1]
        });
        var p2 = proj.unproject({
          x: bbox[0],
          y: bbox[3]
        });
        var p3 = proj.unproject({
          x: bbox[2],
          y: bbox[1]
        });
        var p4 = proj.unproject({
          x: bbox[2],
          y: bbox[3]
        });
        return _leaflet.default.latLngBounds([p1, p2, p3, p4]);
      }

      var southWest = _leaflet.default.latLng(bbox[1], bbox[0]);

      var northEast = _leaflet.default.latLng(bbox[3], bbox[2]);

      var bounds = _leaflet.default.latLngBounds(southWest, northEast);

      return bounds;
    }
    /**
     * Subsets the temporal and vertical axes based on the _axesSubset.*.coordPref property,
     * which is regarded as a preference and does not have to exactly match a coordinate.
     * 
     * The return value is a promise that succeeds with an empty result and
     * sets this._subsetCov to the subsetted coverage.
     * The subsetting always fixes a single time and vertical slice, choosing the first
     * axis value if no preference was given.
     * 
     * After calling this method, _axesSubset.*.idx and _axesSubset.*.coord have
     * values from the actual axes.
     */

  }, {
    key: "_loadCoverageSubset",
    value: function _loadCoverageSubset() {
      var _this3 = this;

      var spec = {};

      for (var _i = 0, _Object$keys = Object.keys(this._axesSubset); _i < _Object$keys.length; _i++) {
        var axis = _Object$keys[_i];
        var ax = this._axesSubset[axis];

        if (!this.domain.axes.has(axis)) {
          continue;
        }

        if (ax.coordPref == undefined) {
          // == also handles null
          spec[axis] = {
            target: this.domain.axes.get(axis).values[0]
          };
        } else {
          spec[axis] = {
            target: ax.coordPref
          };
        }
      }

      this.fire('dataLoading'); // for supporting loading spinners

      return this._cov.subsetByValue(spec).then(function (subsetCov) {
        _this3._subsetCov = subsetCov; //  the goal is to avoid reloading data when approximating palette extent via subsetting
        //  but: memory has to be freed when the layer is removed from the map
        //      -> therefore cacheRanges is set on subsetCov whose reference is removed on onRemove

        subsetCov.cacheRanges = true;
        return Promise.all([subsetCov.loadDomain(), subsetCov.loadRange(_this3._param.key)]);
      }).then(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            subsetDomain = _ref2[0],
            subsetRange = _ref2[1];

        _this3._subsetDomain = subsetDomain;
        _this3._subsetRange = subsetRange;

        _this3.fire('dataLoad');
      }).catch(function (e) {
        _this3.fire('dataLoad');

        throw e;
      });
    }
    /**
     * The coverage object associated to this layer.
     * 
     * @type {Coverage}
     */

  }, {
    key: "coverage",
    get: function get() {
      return this._cov;
    }
    /**
     * The parameter that is visualized.
     * 
     * @type {Parameter}
     */

  }, {
    key: "parameter",
    get: function get() {
      return this._param;
    }
    /**
     * Sets the currently active time to the one closest to the given Date object.
     * Throws an exception if there is no time axis.
     * 
     * @type {Date}
     */

  }, {
    key: "time",
    get:
    /**
     * The currently active time on the temporal axis as Date object, 
     * or undefined if the grid has no time axis.
     * 
     * @type {Date|undefined}
     */
    function get() {
      if (this.domain.axes.has('t')) {
        var time = this._subsetDomain.axes.get('t').values[0];

        return new Date(time);
      }
    }
    /**
     * The time slices that make up the coverage, or undefined if the grid has no time axis .
     * 
     * @type {Array<Date>|undefined}
     */
    ,
    set: function set(val) {
      var _this4 = this;

      if (!this.domain.axes.has('t')) {
        throw new Error('No time axis found');
      }

      var old = this.time;
      this._axesSubset.t.coordPref = val.toISOString();

      this._loadCoverageSubset().then(function () {
        if (old === _this4.time) return;

        _this4.redraw();

        _this4.fire('axisChange', {
          axis: 'time'
        });
      });
    }
  }, {
    key: "timeSlices",
    get: function get() {
      if (this.domain.axes.has('t')) {
        return this.domain.axes.get('t').values.map(function (t) {
          return new Date(t);
        });
      }
    }
    /**
     * Sets the currently active vertical coordinate to the one closest to the given value.
     * 
     * @type {number}
     */

  }, {
    key: "vertical",
    get:
    /**
     * The currently active vertical coordinate as a number, 
     * or undefined if the grid has no vertical axis.
     * 
     * @type {number|undefined}
     */
    function get() {
      if (this.domain.axes.has('z')) {
        var val = this._subsetDomain.axes.get('z').values[0];

        return val;
      }
    }
    /**
     * The vertical slices that make up the coverage, or undefined if the grid has no vertical axis .
     * 
     * @type {Array<number>|undefined}
     */
    ,
    set: function set(val) {
      var _this5 = this;

      if (!this.domain.axes.has('z')) {
        throw new Error('No vertical axis found');
      }

      var old = this.vertical;
      this._axesSubset.z.coordPref = val;

      this._loadCoverageSubset().then(function () {
        if (old === _this5.vertical) return;

        _this5.redraw();

        _this5.fire('axisChange', {
          axis: 'vertical'
        });
      });
    }
  }, {
    key: "verticalSlices",
    get: function get() {
      if (this.domain.axes.has('z')) {
        var vals = this.domain.axes.get('z').values;

        if (ArrayBuffer.isView(vals)) {
          // convert to plain Array to allow easier use
          vals = _toConsumableArray(vals);
        }

        return vals;
      }
    }
    /**
     * See {@link PaletteMixin}.
     * 
     * @ignore
     */

  }, {
    key: "computePaletteExtent",
    value: function computePaletteExtent(extent) {
      var _this6 = this;

      if (extent === 'subset') {
        // scan the current subset for min/max values
        var xlen = this._subsetRange.shape.get(this._projX);

        var ylen = this._subsetRange.shape.get(this._projY); // check if subsetted size is manageable


        if (xlen * ylen < 1000 * 1000) {
          extent = (0, _covutils.minMaxOfRange)(this._subsetRange);
          extent = (0, _palettes.enlargeExtentIfEqual)(extent);
          return Promise.resolve(extent);
        } else {
          var _this$_subsetCov$subs;

          // subset x and y to get a fast estimate of the palette extent
          // since it is an estimate, the lower and upper bound needs a small buffer
          // (to prevent out-of-bounds colours)
          var xconstraint = {
            start: 0,
            stop: xlen,
            step: Math.max(Math.round(xlen / 1000), 1)
          };
          var yconstraint = {
            start: 0,
            stop: ylen,
            step: Math.max(Math.round(ylen / 1000), 1)
          };
          return this._subsetCov.subsetByIndex((_this$_subsetCov$subs = {}, _defineProperty(_this$_subsetCov$subs, this._projX, xconstraint), _defineProperty(_this$_subsetCov$subs, this._projY, yconstraint), _this$_subsetCov$subs)).then(function (subsetCov) {
            return subsetCov.loadRange(_this6._param.key).then(function (subsetRange) {
              var _minMaxOfRange = (0, _covutils.minMaxOfRange)(subsetRange),
                  _minMaxOfRange2 = _slicedToArray(_minMaxOfRange, 2),
                  min = _minMaxOfRange2[0],
                  max = _minMaxOfRange2[1];

              var buffer = (max - min) * 0.1; // 10% buffer on each side

              extent = [min - buffer, max + buffer];
              return extent;
            });
          });
        }
      } else if (extent === 'fov') {
        // scan the values that are currently in field of view on the map for min/max
        // this implies using the current subset
        var bounds = this._map.getBounds(); // TODO implement


        throw new Error('NOT IMPLEMENTED YET');
      } else {
        throw new Error('Unknown extent specification: ' + extent);
      }
    }
    /**
     * Return the displayed value at a given geographic position.
     * If out of bounds, then undefined is returned, otherwise a number or null (for no data).
     * 
     * @param {L.LatLng} latlng
     * @returns {number|null|undefined}
     */

  }, {
    key: "getValueAt",
    value: function getValueAt(latlng) {
      var _this$_subsetRange$ge;

      var X = this.domain.axes.get(this._projX).values;
      var Y = this.domain.axes.get(this._projY).values;

      var bbox = this._getDomainBbox();

      var lat = latlng.lat,
          lng = latlng.lng;

      var _this$projection$proj = this.projection.project({
        lat: lat,
        lon: lng
      }),
          x = _this$projection$proj.x,
          y = _this$projection$proj.y; // we first check whether the tile pixel is outside the domain bounding box
      // in that case we skip it as we do not want to extrapolate


      if (x < bbox[0] || x > bbox[2] || y < bbox[1] || y > bbox[3]) {
        return;
      }

      var iy = (0, _covutils.indexOfNearest)(Y, y);
      var ix = (0, _covutils.indexOfNearest)(X, x);
      return this._subsetRange.get((_this$_subsetRange$ge = {}, _defineProperty(_this$_subsetRange$ge, this._projY, iy), _defineProperty(_this$_subsetRange$ge, this._projX, ix), _this$_subsetRange$ge));
    }
    /**
     * @ignore
     * @override
     * 
     * @param {L.Point} coords The tile coordinates (with z being zoom level).
     * @return {HTMLCanvasElement}
     */

  }, {
    key: "createTile",
    value: function createTile(coords) {
      var tile = _leaflet.default.DomUtil.create('canvas', 'leaflet-tile'); // setup tile width and height according to the options


      var size = this.getTileSize();
      tile.width = size.x;
      tile.height = size.y;
      this.drawTile(tile, coords);
      return tile;
    }
    /**
     * @ignore
     * 
     * @param {HTMLCanvasElement} The canvas to draw on.
     * @param {L.Point} coords The tile coordinates (with z being zoom level).
     */

  }, {
    key: "drawTile",
    value: function drawTile(canvas, coords) {
      if (this._errored) return;
      var ctx = canvas.getContext('2d');
      var tileSize = this.getTileSize();
      var imgData = ctx.getImageData(0, 0, tileSize.x, tileSize.y); // Uint8ClampedArray, 1-dimensional, in order R,G,B,A,R,G,B,A,... row-major

      var rgba = (0, _ndarray.default)(imgData.data, [tileSize.y, tileSize.x, 4]);
      var setPixel;
      var valueToColor = this.options.valueToColor;

      if (valueToColor) {
        setPixel = function setPixel(tileY, tileX, val) {
          var color = valueToColor(val);

          if (color !== undefined && color !== null) {
            rgba.set(tileY, tileX, 0, color.r);
            rgba.set(tileY, tileX, 1, color.g);
            rgba.set(tileY, tileX, 2, color.b);
            rgba.set(tileY, tileX, 3, color.hasOwnProperty('a') ? color.a : 255);
          }
        };
      } else {
        var _this$palette = this.palette,
            red = _this$palette.red,
            green = _this$palette.green,
            blue = _this$palette.blue;
        var getPaletteIndex = this.getPaletteIndex;

        setPixel = function setPixel(tileY, tileX, val) {
          var idx = getPaletteIndex(val);

          if (idx !== undefined) {
            rgba.set(tileY, tileX, 0, red[idx]);
            rgba.set(tileY, tileX, 1, green[idx]);
            rgba.set(tileY, tileX, 2, blue[idx]);
            rgba.set(tileY, tileX, 3, 255);
          }
        };
      }

      var vals = this._subsetRange.get;

      if (this._isDomainUsingEllipsoidalCRS()) {
        if (this._isRectilinearGeodeticMap()) {
          // here we can apply heavy optimizations as the map CRS matches the domain CRS 
          this._drawGeodeticCRSWithRectilinearMapProjection(setPixel, coords, vals);
        } else {
          // this is for any random map projection
          // here we have to unproject each map pixel individually and find the matching domain index coordinates
          this._drawGeodeticCRSWithAnyMapProjection(setPixel, coords, vals);
        }
      } else {
        // here we have to unproject each map pixel individually, 
        // project it into domain projection coordinates, and find the domain index coordinates
        if (this._isRectilinearGeodeticMap()) {
          this._drawProjectedCRSWithRectilinearMapProjection(setPixel, coords, vals);
        } else {
          this._drawProjectedCRSWithAnyMapProjection(setPixel, coords, vals);
        }
      }

      ctx.putImageData(imgData, 0, 0);
    }
    /**
     * Derives the bounding box of the x,y CRS axes in domain CRS coordinates.
     * 
     * @return {Array} [xmin,ymin,xmax,ymax]
     */

  }, {
    key: "_getDomainBbox",
    value: function _getDomainBbox() {
      var extent = function extent(x, xBounds) {
        var xend = x.length - 1;
        var xmin, xmax;

        if (xBounds) {
          var _ref3 = [xBounds.get(0)[0], xBounds.get(xend)[1]];
          xmin = _ref3[0];
          xmax = _ref3[1];
        } else {
          var _ref4 = [x[0], x[xend]];
          xmin = _ref4[0];
          xmax = _ref4[1];
        }

        var xDescending = xmin > xmax;

        if (xDescending) {
          var _ref5 = [xmax, xmin];
          xmin = _ref5[0];
          xmax = _ref5[1];
        }

        if (!xBounds && x.length > 1) {
          if (xDescending) {
            xmin -= (x[xend - 1] - x[xend]) / 2;
            xmax += (x[0] - x[1]) / 2;
          } else {
            xmin -= (x[1] - x[0]) / 2;
            xmax += (x[xend] - x[xend - 1]) / 2;
          }
        }

        return [xmin, xmax];
      };

      var xAxis = this.domain.axes.get(this._projX);
      var yAxis = this.domain.axes.get(this._projY);

      var _extent = extent(xAxis.values, xAxis.bounds),
          _extent2 = _slicedToArray(_extent, 2),
          xmin = _extent2[0],
          xmax = _extent2[1];

      var _extent3 = extent(yAxis.values, yAxis.bounds),
          _extent4 = _slicedToArray(_extent3, 2),
          ymin = _extent4[0],
          ymax = _extent4[1];

      return [xmin, ymin, xmax, ymax];
    }
    /**
     * Draws a geodetic rectilinear domain grid on a map with arbitrary projection.
     * 
     * @param {Function} setPixel A function with parameters (y,x,val) which 
     *                            sets the color of a pixel on a tile.
     * @param {L.Point} coords The tile coordinates.
     * @param {function(idx: Object): number|null} vals Range value function.
     */

  }, {
    key: "_drawGeodeticCRSWithAnyMapProjection",
    value: function _drawGeodeticCRSWithAnyMapProjection(setPixel, coords, vals) {
      // usable for any map projection, but computationally more intensive
      // there are two hotspots in the loops: map.unproject and indexOfNearest
      // Note that this function is slightly more specialized and optimized than _drawProjectedCRSWithAnyMapProjection().
      // It targets the case when the domain is lat/lon, whereas _drawProjectedCRSWithAnyMapProjection() works
      // with any projected CRS in the grid domain.
      var tileSize = this.getTileSize();
      var startX = coords.x * tileSize.x;
      var startY = coords.y * tileSize.y;
      var zoom = coords.z;
      var map = this._map;
      var x = this.domain.axes.get('x').values;
      var y = this.domain.axes.get('y').values;

      var bbox = this._getDomainBbox(); // a bit hacky


      if (this._projX === 'y') {
        bbox = [bbox[1], bbox[0], bbox[3], bbox[2]];
      }

      var lonRange = [bbox[0], bbox[0] + 360];

      for (var tileX = 0; tileX < tileSize.x; tileX++) {
        for (var tileY = 0; tileY < tileSize.y; tileY++) {
          var _map$unproject = map.unproject(_leaflet.default.point(startX + tileX, startY + tileY), zoom),
              lat = _map$unproject.lat,
              lng = _map$unproject.lng; // we first check whether the tile pixel is outside the domain bounding box
          // in that case we skip it as we do not want to extrapolate


          if (lat < bbox[1] || lat > bbox[3]) {
            continue;
          }

          lng = wrapLongitude(lng, lonRange);

          if (lng < bbox[0] || lng > bbox[2]) {
            continue;
          } // now we find the closest grid cell using simple binary search
          // for finding the closest latitude/longitude we use a simple binary search
          // (as there is no discontinuity)


          var iLat = (0, _covutils.indexOfNearest)(y, lat);
          var iLon = (0, _covutils.indexOfNearest)(x, lng);
          setPixel(tileY, tileX, vals({
            y: iLat,
            x: iLon
          }));
        }
      }
    }
    /**
     * Draws a domain with projected CRS on a map with arbitrary projection.
     * 
     * @param {Function} setPixel A function with parameters (y,x,val) which 
     *                            sets the color of a pixel on a tile.
     * @param {L.Point} coords The tile coordinates.
     * @param {function(idx: Object): number|null} vals Range value function.
     */

  }, {
    key: "_drawProjectedCRSWithAnyMapProjection",
    value: function _drawProjectedCRSWithAnyMapProjection(setPixel, coords, vals) {
      var map = this._map;
      var X = this.domain.axes.get(this._projX).values;
      var Y = this.domain.axes.get(this._projY).values;

      var bbox = this._getDomainBbox();

      var proj = this.projection;
      var tileSize = this.getTileSize();
      var startX = coords.x * tileSize.x;
      var startY = coords.y * tileSize.y;
      var zoom = coords.z;

      for (var tileX = 0; tileX < tileSize.x; tileX++) {
        for (var tileY = 0; tileY < tileSize.y; tileY++) {
          var _map$unproject2 = map.unproject(_leaflet.default.point(startX + tileX, startY + tileY), zoom),
              lat = _map$unproject2.lat,
              lng = _map$unproject2.lng;

          var _proj$project = proj.project({
            lat: lat,
            lon: lng
          }),
              x = _proj$project.x,
              y = _proj$project.y; // we first check whether the tile pixel is outside the domain bounding box
          // in that case we skip it as we do not want to extrapolate


          if (x < bbox[0] || x > bbox[2] || y < bbox[1] || y > bbox[3]) {
            continue;
          } // now we find the closest grid cell using simple binary search


          var iy = (0, _covutils.indexOfNearest)(Y, y);
          var ix = (0, _covutils.indexOfNearest)(X, x);
          setPixel(tileY, tileX, vals({
            y: iy,
            x: ix
          }));
        }
      }
    }
    /**
     * Draws a domain with projected CRS on a map with rectilinear lon/lat projection.
     * 
     * @param {Function} setPixel A function with parameters (y,x,val) which 
     *                            sets the color of a pixel on a tile.
     * @param {L.Point} coords The tile coordinates.
     * @param {function(idx: Object): number|null} vals Range value function.
     */

  }, {
    key: "_drawProjectedCRSWithRectilinearMapProjection",
    value: function _drawProjectedCRSWithRectilinearMapProjection(setPixel, coords, vals) {
      var map = this._map;
      var X = this.domain.axes.get(this._projX).values;
      var Y = this.domain.axes.get(this._projY).values;

      var bbox = this._getDomainBbox();

      var proj = this.projection;
      var tileSize = this.getTileSize();
      var startX = coords.x * tileSize.x;
      var startY = coords.y * tileSize.y;
      var zoom = coords.z; // since the map projection is a rectilinear lat/lon grid,
      // we only have to unproject the the first row and column to get the lat/lon coordinates of all tile pixels

      var lons = new Float64Array(tileSize.x);

      for (var tileX = 0; tileX < tileSize.x; tileX++) {
        var _map$unproject3 = map.unproject(_leaflet.default.point(startX + tileX, startY), zoom),
            lng = _map$unproject3.lng;

        lons[tileX] = lng;
      }

      var lats = new Float64Array(tileSize.y);

      for (var tileY = 0; tileY < tileSize.y; tileY++) {
        var _map$unproject4 = map.unproject(_leaflet.default.point(startX, startY + tileY), zoom),
            lat = _map$unproject4.lat;

        lats[tileY] = lat;
      }

      for (var _tileX = 0; _tileX < tileSize.x; _tileX++) {
        for (var _tileY = 0; _tileY < tileSize.y; _tileY++) {
          var _lat = lats[_tileY];
          var lon = lons[_tileX];

          var _proj$project2 = proj.project({
            lat: _lat,
            lon: lon
          }),
              x = _proj$project2.x,
              y = _proj$project2.y; // we first check whether the tile pixel is outside the domain bounding box
          // in that case we skip it as we do not want to extrapolate


          if (x < bbox[0] || x > bbox[2] || y < bbox[1] || y > bbox[3]) {
            continue;
          } // now we find the closest grid cell using simple binary search


          var iy = (0, _covutils.indexOfNearest)(Y, y);
          var ix = (0, _covutils.indexOfNearest)(X, x);
          setPixel(_tileY, _tileX, vals({
            y: iy,
            x: ix
          }));
        }
      }
    }
    /**
     * Draws a geodetic rectilinear domain grid on a map whose grid is, or can be directly
     * mapped to, a geodetic rectilinear grid.
     * 
     * @param {Function} setPixel A function with parameters (y,x,val) which 
     *                            sets the color of a pixel on a tile.
     * @param {L.Point} coords The tile coordinates.
     * @param {function(idx: Object): number|null} vals Range value function.
     */

  }, {
    key: "_drawGeodeticCRSWithRectilinearMapProjection",
    value: function _drawGeodeticCRSWithRectilinearMapProjection(setPixel, coords, vals) {
      // optimized version for map projections that are equal to a rectilinear geodetic grid
      // this can be used when lat and lon can be computed independently for a given pixel
      var map = this._map;
      var x = this.domain.axes.get('x').values;
      var y = this.domain.axes.get('y').values;

      var bbox = this._getDomainBbox(); // a bit hacky


      if (this._projX === 'y') {
        bbox = [bbox[1], bbox[0], bbox[3], bbox[2]];
      }

      var lonRange = [bbox[0], bbox[0] + 360];
      var tileSize = this.getTileSize();
      var startX = coords.x * tileSize.x;
      var startY = coords.y * tileSize.y;
      var zoom = coords.z;
      var latCache = new Float64Array(tileSize.y);
      var iLatCache = new Uint32Array(tileSize.y);

      for (var tileY = 0; tileY < tileSize.y; tileY++) {
        var lat = map.unproject(_leaflet.default.point(startX, startY + tileY), zoom).lat;
        latCache[tileY] = lat; // find the index of the closest latitude in the grid using simple binary search

        iLatCache[tileY] = (0, _covutils.indexOfNearest)(y, lat);
      }

      for (var tileX = 0; tileX < tileSize.x; tileX++) {
        var lon = map.unproject(_leaflet.default.point(startX + tileX, startY), zoom).lng;
        lon = wrapLongitude(lon, lonRange);

        if (lon < bbox[0] || lon > bbox[2]) {
          continue;
        } // find the index of the closest longitude in the grid using simple binary search
        // (as there is no discontinuity)


        var iLon = (0, _covutils.indexOfNearest)(x, lon);

        for (var _tileY2 = 0; _tileY2 < tileSize.y; _tileY2++) {
          // get geographic coordinates of tile pixel
          var _lat2 = latCache[_tileY2]; // we first check whether the tile pixel is outside the domain bounding box
          // in that case we skip it as we do not want to extrapolate

          if (_lat2 < bbox[1] || _lat2 > bbox[3]) {
            continue;
          }

          var iLat = iLatCache[_tileY2];
          setPixel(_tileY2, tileX, vals({
            y: iLat,
            x: iLon
          }));
        }
      }
    }
    /**
     * Return true if the map projection grid can be mapped to a rectilinear
     * geodetic grid. For that, it must satisfy:
     * for all x, there is a longitude lon, for all y, unproject(x,y).lon = lon
     * for all y, there is a latitude lat, for all x, unproject(x,y).lat = lat
     * 
     * Returns false if this is not the case or unknown.
     */

  }, {
    key: "_isRectilinearGeodeticMap",
    value: function _isRectilinearGeodeticMap() {
      var crs = this._map.options.crs; // these are the ones included in Leaflet

      var recti = [_leaflet.default.CRS.EPSG3857, _leaflet.default.CRS.EPSG4326, _leaflet.default.CRS.EPSG3395, _leaflet.default.CRS.Simple];
      var isRecti = recti.indexOf(crs) !== -1; // TODO for unknown ones, how do we test that?

      return isRecti;
    }
    /**
     * Return whether the coverage domain is using a geodetic CRS with WGS84 datum.
     */

  }, {
    key: "_isDomainUsingEllipsoidalCRS",
    value: function _isDomainUsingEllipsoidalCRS() {
      return this.domain.referencing.some(function (ref) {
        return (0, _covutils.isEllipsoidalCRS)(ref.system);
      });
    }
    /**
     * @ignore
     * @override
     */

  }, {
    key: "redraw",
    value: function redraw() {
      // we check getContainer() to prevent errors when trying to redraw when the layer has not
      // fully initialized yet
      if (this.getContainer()) {
        _leaflet.default.GridLayer.prototype.redraw.call(this);
      }
    }
  }]);

  return Grid;
}((0, _PaletteMixin2.PaletteMixin)((0, _CoverageMixin.CoverageMixin)(_leaflet.default.GridLayer)));

exports.Grid = Grid;

function wrapLongitude(lon, range) {
  return _leaflet.default.Util.wrapNum(lon, range, true);
}