"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PaletteMixin = PaletteMixin;

var _palettes = require("./palettes.js");

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DEFAULT_CONTINUOUS_PALETTE = function DEFAULT_CONTINUOUS_PALETTE() {
  return (0, _palettes.linearPalette)(['#deebf7', '#3182bd']);
}; // blues


var DEFAULT_CATEGORICAL_PALETTE = function DEFAULT_CATEGORICAL_PALETTE(n) {
  if (n > 12) {
    throw new Error('not enough built-in categorical colors, must supply custom colors');
  }

  return (0, _palettes.directPalette)(['#a6cee3', '#1f78b4', '#b2df8a', '#33a02c', '#fb9a99', '#e31a1c', '#fdbf6f', '#ff7f00', '#cab2d6', '#6a3d9a', '#ffff99', '#b15928'].slice(0, n));
};
/**
 * The `paletteChange` event, signalling that the palette has changed.
 * 
 * @typedef {L.Event} PaletteMixin#paletteChange
 */

/**
 * The `paletteExtentChange` event, signalling that the palette extent has changed.
 * 
 * @typedef {L.Event} PaletteMixin#paletteExtentChange
 */

/**
 * A mixin that encapsulates the palette logic of a coverage layer,
 * supporting categorical and continuous coverage parameters.
 * 
 * The following functions/properties are supplied:
 * 
 * - initializePalette() - to be called once data has been loaded so that computePaletteExtent can be called
 * - get/set palette
 * - get/set paletteExtent
 * - setPaletteExtent(extent) - like set paletteExtent, but returns a Promise to know when calculations etc. are done
 * - getPaletteIndex(val) - returns the color index for the given value
 * 
 * The base class must supply the following functions/properties:
 * 
 * - options.palette (optional)
 * - options.paletteExtent (optional) - initial value that computePaletteExtent is called with
 * - parameter
 * - redraw()
 * - computePaletteExtent(extent) - returns a Promise with the computed extent; gets called when .paletteExtent is set to a string value
 * - canUsePalette() (optional) - if this method exists and returns false, then .palette returns undefined
 * 
 * @param {class} base The base class.
 * @return {class} The base class with PaletteMixin.
 */


function PaletteMixin(base) {
  return /*#__PURE__*/function (_base) {
    _inherits(_class, _base);

    var _super = _createSuper(_class);

    function _class() {
      _classCallCheck(this, _class);

      return _super.apply(this, arguments);
    }

    _createClass(_class, [{
      key: "initializePalette",
      value: function initializePalette() {
        var _this = this;

        var options = this.options;
        var parameter = this.parameter;

        if (!parameter) {
          return Promise.resolve();
        }

        var categories = parameter.observedProperty.categories;

        if (categories) {
          this._initCategoryIdxMap();
        }

        if (this._palette) {// do nothing, already set
        } else if (options.palette) {
          this._palette = options.palette;
        } else if (parameter.preferredPalette) {
          this._palette = (0, _palettes.paletteFromObject)(parameter.preferredPalette);
        } else if (categories) {
          if (categories.every(function (cat) {
            return cat.preferredColor;
          })) {
            this._palette = (0, _palettes.directPalette)(categories.map(function (cat) {
              return cat.preferredColor;
            }));
          } else {
            this._palette = DEFAULT_CATEGORICAL_PALETTE(categories.length);
          }
        } else {
          this._palette = DEFAULT_CONTINUOUS_PALETTE();
        }

        if (categories && categories.length !== this._palette.steps) {
          throw new Error('Categorical palettes must match the number of categories of the parameter');
        }

        this._paletteExtent = this._paletteExtent || options.paletteExtent;
        this._extendMax = !!options.extendMax;
        this._extendMin = !!options.extendMin;

        if (this.parameter.categoryEncoding) {
          // categorical parameter, does not depend on palette extent
          var valIdxMap = this._categoryIdxMap;
          var max = valIdxMap.length - 1;

          this.getPaletteIndex = function (val) {
            if (val === null || val < 0 || val > max) return;
            var idx = valIdxMap[val];
            if (idx === 255) return;
            return idx;
          };
        }

        if (!this.canUsePalette || this.canUsePalette()) {
          return this.setPaletteExtent(this._paletteExtent, true).then(function () {
            return _this._updatePaletteIndexFn();
          });
        } else {
          return Promise.resolve();
        }
      }
    }, {
      key: "_updatePaletteIndexFn",
      value: function _updatePaletteIndexFn() {
        var _this2 = this;

        if (!this.parameter.categoryEncoding) {
          // continuous parameter
          var palette = this.palette;
          var extent = this.paletteExtent;

          this.getPaletteIndex = function (val) {
            if (val === null) return;

            if (val > extent[1]) {
              if (_this2._extendMax) {
                return palette.steps - 1;
              } else {
                return;
              }
            }

            if (val < extent[0]) {
              if (_this2._extendMin) {
                return 0;
              } else {
                return;
              }
            }

            var idx = (0, _palettes.scale)(val, palette, extent);
            return idx;
          };
        }
      }
    }, {
      key: "palette",
      get: function get() {
        if (this.parameter && (!this.canUsePalette || this.canUsePalette())) {
          return this._palette;
        }
      },
      set: function set(p) {
        this._palette = p;

        this._updatePaletteIndexFn();

        this.redraw();
        this.fire('paletteChange');
      }
    }, {
      key: "paletteExtent",
      get: function get() {
        return this._paletteExtent;
      },
      set: function set(extent) {
        this.setPaletteExtent(extent);
      }
    }, {
      key: "setPaletteExtent",
      value: function setPaletteExtent(extent, skipRedraw) {
        var _this3 = this;

        if (this.parameter.observedProperty.categories) {
          return Promise.resolve();
        }

        var oldExtent = this.paletteExtent;

        var hasChanged = function hasChanged(newExtent) {
          if (!Array.isArray(oldExtent)) return true;
          if (oldExtent[0] !== newExtent[0] || oldExtent[1] !== newExtent[1]) return true;
          return false;
        };

        var res = Array.isArray(extent) ? Promise.resolve(extent) : this.computePaletteExtent(extent);
        return res.then(function (newExtent) {
          // ignore invalid extents (may come from using ParameterSync)
          if (Array.isArray(newExtent) && isNaN(newExtent[0])) return;
          if (!hasChanged(newExtent)) return;
          _this3._paletteExtent = newExtent;

          _this3._updatePaletteIndexFn();

          if (!skipRedraw) {
            _this3.redraw();
          }

          _this3.fire('paletteExtentChange');
        });
      }
      /**
       * Sets up a lookup table from categorical range value to palette index.
       */

    }, {
      key: "_initCategoryIdxMap",
      value: function _initCategoryIdxMap() {
        var param = this.parameter;
        if (!param.categoryEncoding) return; // categorical parameter with integer encoding
        // Note: The palette order is equal to the categories array order.

        var max = -Infinity;
        var min = Infinity;
        var categories = param.observedProperty.categories;
        var encoding = param.categoryEncoding;

        var _iterator = _createForOfIteratorHelper(categories),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var _category = _step.value;

            if (encoding.has(_category.id)) {
              var _iterator3 = _createForOfIteratorHelper(encoding.get(_category.id)),
                  _step3;

              try {
                for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                  var _val = _step3.value;
                  max = Math.max(max, _val);
                  min = Math.min(min, _val);
                }
              } catch (err) {
                _iterator3.e(err);
              } finally {
                _iterator3.f();
              }
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }

        var valIdxMap;

        if (categories.length < 256) {
          if (max > 10000 || min < 0) {
            // TODO implement fallback to Map implementation
            throw new Error('category values too high (>10000) or low (<0)');
          }

          valIdxMap = new Uint8Array(max + 1);

          for (var i = 0; i <= max; i++) {
            // the above length < 256 check ensures that no palette index is ever 255
            valIdxMap[i] = 255;
          }

          for (var idx = 0; idx < categories.length; idx++) {
            var category = categories[idx];

            if (encoding.has(category.id)) {
              var _iterator2 = _createForOfIteratorHelper(param.categoryEncoding.get(category.id)),
                  _step2;

              try {
                for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                  var val = _step2.value;
                  valIdxMap[val] = idx;
                }
              } catch (err) {
                _iterator2.e(err);
              } finally {
                _iterator2.f();
              }
            }
          }
        } else {
          throw new Error('Too many categories: ' + categories.length);
        }

        this._categoryIdxMap = valIdxMap;
      }
    }]);

    return _class;
  }(base);
}