"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ValuePopup = void 0;

var _leaflet = _interopRequireDefault(require("leaflet"));

var _covutils = require("covutils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * A popup that contains the parameter values of the given coverage layers at the location of the popup.
 * 
 * The popup content is updated when one of the following occurs:
 * - popup is added to a map
 * - popup location is changed
 * - coverage layer is added or removed
 * - updateData() is called
 * 
 * @extends {L.Popup}
 */
var ValuePopup = /*#__PURE__*/function (_L$Popup) {
  _inherits(ValuePopup, _L$Popup);

  var _super = _createSuper(ValuePopup);

  /**
   * @param {Object} [options] The options object.
   * @param {number} [options.maxDistanceForPointsInPx=20]
   *   The maximum distance in pixels from the popup location for which point-data values should be included.
   * @param {Array<DataLayer>} [options.layers] An initial set of coverage data layers.
   * @param {L.Layer} [source] Used to tag the popup with a reference to the Layer to which it refers.
   */
  function ValuePopup(options, source) {
    var _this;

    _classCallCheck(this, ValuePopup);

    _this = _super.call(this, options, source);
    var layers = _this.options.layers || [];
    _this._maxDistanceForPointsInPx = _this.options.maxDistanceForPointsInPx || 20;
    /**
     * The coverage data layers added to this popup.
     * 
     * @type {Set<DataLayer>}
     */

    _this.coverageLayers = new Set(layers.filter(function (layer) {
      return layer.getValueAt;
    }));
    return _this;
  }
  /**
   * @param {DataLayer} layer The data layer to add.
   * @return {this}
   */


  _createClass(ValuePopup, [{
    key: "addCoverageLayer",
    value: function addCoverageLayer(layer) {
      if (!layer.getValueAt) return this;
      this.coverageLayers.add(layer);
      this.updateData();
      return this;
    }
    /**
     * @param {DataLayer} layer The data layer to remove.
     * @return {this}
     */

  }, {
    key: "removeCoverageLayer",
    value: function removeCoverageLayer(layer) {
      this.coverageLayers.delete(layer);
      this.updateData();
      return this;
    }
    /**
     * @ignore
     * @override
     */

  }, {
    key: "onAdd",
    value: function onAdd(map) {
      this._map = map;

      _get(_getPrototypeOf(ValuePopup.prototype), "onAdd", this).call(this, map);

      this.updateData();
    }
    /**
     * @ignore
     * @override
     */

  }, {
    key: "onRemove",
    value: function onRemove(map) {
      _get(_getPrototypeOf(ValuePopup.prototype), "onRemove", this).call(this, map);

      this._map = null;
    }
    /**
     * @ignore
     * @override
     */

  }, {
    key: "setLatLng",
    value: function setLatLng(latlng) {
      _get(_getPrototypeOf(ValuePopup.prototype), "setLatLng", this).call(this, latlng);

      this.updateData();
      return this;
    }
    /**
     * Returns whether there is any non-missing coverage data at the current popup location.
     * This function only works after the popup has been added to the map.
     * 
     * @return {boolean}
     */

  }, {
    key: "hasData",
    value: function hasData() {
      return this._hasData;
    }
    /**
     * Updates the popup content from the data layers.
     * Gets called automatically when `setLatLng` is called.
     * 
     * @return {this}
     */

  }, {
    key: "updateData",
    value: function updateData() {
      if (!this._map) return;
      var html = '';
      var latlng = this.getLatLng();

      var _iterator = _createForOfIteratorHelper(this.coverageLayers),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var layer = _step.value;

          var maxDistance = getMetersPerPixel(this._map) * this._maxDistanceForPointsInPx;

          var val = layer.getValueAt(latlng, maxDistance);
          if (val == null) continue;
          var param = layer.parameter;
          var unit = !param.observedProperty.categories ? (0, _covutils.stringifyUnit)(param.unit) : '';

          if (param.categoryEncoding) {
            var cat = (0, _covutils.getCategory)(param, val);
            val = (0, _covutils.getLanguageString)(cat.label);
          }

          html += '<div><strong>' + (0, _covutils.getLanguageString)(param.observedProperty.label) + '</strong>: ' + val + ' ' + unit + '</div>';
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      if (!html) {
        this._hasData = false;
        html = 'No data.';
      }

      this._hasData = true;
      this.setContent(html);
      return this;
    }
  }]);

  return ValuePopup;
}(_leaflet.default.Popup);

exports.ValuePopup = ValuePopup;

function getMetersPerPixel(map) {
  // from L.Control.Scale
  var bounds = map.getBounds();
  var centerLat = bounds.getCenter().lat;
  var halfWorldMeters = 6378137 * Math.PI * Math.cos(centerLat * Math.PI / 180);
  var dist = halfWorldMeters * (bounds.getNorthEast().lng - bounds.getSouthWest().lng) / 180;
  var size = map.getSize();
  var perpx = dist / size.x;
  return perpx;
}